#include <iostream>
#include <math.h>
#define cin std::cin
#define cout std::cout
#define endl std::endl
#define swap std::swap
//using namespace std;
struct vec
{
       double x,y;
};

double v1,v2,d1,d2,t1,t2,c1,c2,a1,a2,step,sin1,sin2,cos1,cos2;
vec Va,Vb,next1,next2;
vec rotate(vec tv,double vsin,double vcos,double dir)
{
    return (vec) {vcos*tv.x+dir*vsin*tv.y,-dir*vsin*tv.x+vcos*tv.y};
}

double dist(vec A)
{
       return sqrt(A.x*A.x+A.y*A.y);
}
double CP(vec A,vec B)
{
       return A.x*B.y-A.y*B.x;
}
double SP(vec A,vec B)
{
       return A.x*B.x+A.y*B.y;
}

double TIME;
int K;
int main()
{
       cin>>Va.x>>Va.y>>v1>>d1;
       cin>>Vb.x>>Vb.y>>v2>>d2;

       cin>>K;

       c1=2.0*M_PI*dist(Va);
       c2=2.0*M_PI*dist(Vb);
       
       t1=c1/v1;
       t2=c2/v2;
       
       if(0)
       {
                  step=t1/360.0;
                  a1=M_PI/180.0;
                  a2=((step*v2)/c2)*2.0*M_PI;
                  sin1=sin(a1);
                  sin2=sin(a2);
                  cos1=cos(a1);
                  cos2=cos(a2);
                  int tk=0;
                  double ttime=0;
                  while(tk<K)
                  {
                             next1=rotate(Va,sin1,cos1,d1);
                             next2=rotate(Vb,sin2,cos2,d2);
                             ttime+=step;
                            // cout<<Va.x<<" "<<Va.y<<" "<<Vb.x<<" "<<Vb.y<<":"<<ttime<<" "<<tk<<endl;
                            // system("PAUSE");
                             if(CP(Va,Vb)*CP(next1,next2)<=0 && Va.x*Vb.x>=0 && Va.y*Vb.y>=0)
                             {
                                                             
                                                            tk++;
                                                            if(tk==K) break;
                                                            
                                                            while(CP(next1,next2)==0)
                                                            {
                                                            next1=rotate(next1,sin1,cos1,d1);                                                     
                                                            next2=rotate(next2,sin2,cos2,d2);
                                                            ttime+=step;
                                                            }
                                                            
                             }
                             Va=next1;
                             Vb=next2;           
                  }
                  cout<<(int)ttime<<endl;
       }
       else
       {
           
           a1=360.0/t1;
           a2=360.0/t2;
           
           if(a1>a2)
           {
                    swap(Va,Vb);
                    swap(v1,v2);
                    swap(d1,d2);
                    swap(a1,a2);
                    swap(t1,t2);
                    swap(c1,c2);
           }
           
           double da=(d1*d2<0)? a2+a1 : a2-a1;
           double cosa=SP(Va,Vb)/(dist(Va)*dist(Vb));
           double alpha=acos(cosa);
           if((-1.0)*d1*CP(Vb,Va)<0) alpha=2.0*M_PI-alpha;
           alpha=(alpha/(2.0*M_PI))*360.0;
           
           cout<<(int)((alpha+360.0*((double)K-1.))/da)<<endl;
           return 0;
       }

}
