#include <iostream>
#include <cmath>

using namespace std;

typedef double ft;

ft PI = 3.1415926535897932384626433832795;

ft norm(ft a) {
	while(a < 0) a += 2*PI;
	return a;
}

struct body {
	ft x, y, v, d;
	ft r, rv, a;
	body() { }
	void read() {
		cin>>x>>y>>v>>d;
	}
	void compute() {
		a = norm(atan2(y, x));
		r = hypot(x, y);
		rv = v / r;
	}
} b1, b2;

#define TV(v) cout<<#v<<": "<<v<<endl;

int cmp(ft a, ft b) {
	return (a>b)-(a<b);
}

int main() {
	b1.read(); b1.compute();
	b2.read(); b2.compute();
	int k;
	cin>>k;
	if(b1.a > b2.a) {
		body b3 = b1;
		b1 = b2; b2 = b3;
	}
	double nad;
	nad = norm(b2.d*cmp(b1.a, b2.a)*(b1.a - b2.a));
		/*if(b1.d == -1 && b2.d == -1) {
			nad = norm(b1.a - b2.a);
		} else if(b1.d == -1 && b2.d == 1) {
			nad = norm(b2.a - b1.a);
		} else if(b1.d == 1 && b2.d == -1) {
			nad = norm(b1.a - b2.a);
		} else if(b1.d == 1 && b2.d == 1) {
			nad = norm(b2.a - b1.a);
		}
	if(b1.a > b2.a) nad = norm(-nad);*/
	
	double rrv = b2.d*b2.rv - b1.d*b1.rv;
	double te1 = nad / rrv;
	double tfc = 2*PI / rrv;
	/*TV(b1.a);
	TV(b2.a);
	TV(nad);
	TV(rrv);
	TV(te1);
	TV(tfc);*/
	cout<<abs((int)(te1+tfc*(k-1)))<<endl;
	return 0;
}
