#include <stdio.h>
#include <stdlib.h>

#define MAX 512

int latinsq[MAX][MAX];
int cols[MAX][MAX];

int n;
int found=0;

void slave(int row,int num)
{
    int i;
    for(i=0;i<n;++i)
        if(cols[i][num]==0&&latinsq[row][i]==0)
        {
            cols[i][num]=1;
            latinsq[row][i]=num;
            if(num==n)
            {
                if(row==n-1)
                {
                    found=1;
                    return;
                }
                slave(row+1,1);
                if(found)
                    return;
            }
            else
            {
                slave(row,num+1);
                if(found)
                    return;
            }
            cols[i][num]=0;
            latinsq[row][i]=0;
        }
}


int main()
{
    int m,i,j;
    scanf("%d%d",&m,&n);
    for(i=0;i<m;++i)
    {
        for(j=0;j<n;++j)
        {
            scanf("%d",latinsq[i]+j);
            cols[j][latinsq[i][j]]=1;
        }
    }
    slave(m,1);
    printf("%d\n",n);
    for(i=0;i<n;++i)
    {
        for(j=0;j<n;++j)
        {
            printf("%d", latinsq[i][j]);
            if(j!=n-1)
            putchar(' ');
        }
        putchar('\n');
    }
    return 0;
}
