#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define KILL_TIME 4972
#define MAX 0x7fff
int sol[MAX];
int sol_size=0;
int poisoned[MAX];
int n;
void back_track(int cu)
{
 static int path[MAX];
 static int path_size=0;
 static int moved;
 if(clock()>=KILL_TIME)
   goto longer_path_found;
// printf("%d\n",clock());
 path[path_size++]=cu;
 moved=0;
 for(int i=0;i<n;++i)
  if(!poisoned[cu^(1<<i)])
  {
   moved=1;
   poisoned[cu]=cu+1;
   for(int j=0;j<n;++j)
   {
    if(j!=i&&poisoned[cu^(1<<j)]==0)
      poisoned[cu^(1<<j)]=cu+1;
   }
   back_track(cu^(1<<i));
   poisoned[cu]=0;
   for(int j=0;j<n;++j)
     if(j!=i&&poisoned[cu^(1<<j)]==cu+1)
       poisoned[cu^(1<<j)]=0;
  }
 if(!moved)
longer_path_found:
   if(sol_size<path_size)
   {
    sol_size=path_size;
    for(int i=0;i<path_size;++i)
      sol[i]=path[i];
   }
 --path_size;
}

int main()
{
 scanf("%d",&n);
 back_track(0);
 printf("%d\n",(int)sol_size);
 //int sol_size=sol.size();
 for(int i=0;i<sol_size;++i)
 {
   for(int j=0;j<n;++j)
   {
    printf("%d",(sol[i]&1<<j)?1:0);
    if(j!=n-1)
        putchar(' ');
   }
   putchar('\n');
 }
 //printf("time is %d",clock());
 return 0;
}
