#include <iostream>
#include <cstdio>

using namespace std;

int used[512];
int n, m;
int A[512][512];

void print()
{
    for (int i=0; i<m; ++i, printf("\n"))
        for (int j=0; j<m; ++j)
            printf("%d ", A[i][j]);
}

bool check(int a, int b)
{
    memset(used, 0, sizeof(used));
    for (int i=0; i<m; ++i)
    {
        ++used[A[a][i]];
        if (used[A[a][i]]>1 && A[a][i]!=0)
            return false;
    }
    memset(used, 0, sizeof(used));
    for (int i=0; i<m; ++i)
    {
        ++used[A[i][b]];
        if (used[A[i][b]]>1 && A[i][b]!=0)
            return false;
    }
    return true;
}

void generate_next()
{
    for (int i=0; i<=n; ++i)
    {
        for (int j=0; j<m; ++j)
        {
            A[n][i]=j+1;
            if (check(n, i))
                break;
        }
    }
}

void generate(int k)
{
    for (int j=n; j<k; ++j)
        for (int i=0; i<m; ++i)
        {
            A[j][k]=i+1;
            if (check(j, k))
                break;
        }
    for (int i=0; i<=k; ++i)
    {
        for (int j=0; j<m; ++j)
        {
            A[k][i]=j+1;
            if (check(k, i))
                break;
        }
    }
}

void solve()
{
    generate_next();
    for (int i=n+1; i<m; ++i)
        generate(i);
}

void input()
{
    scanf("%d%d", &n, &m);
    for (int i=0; i<n; ++i)
        for (int j=0; j<m; ++j)
            scanf("%d", &A[i][j]);
}

int main()
{
    input();
    printf("%d\n",m);
    solve();
    print();
return 0;
}
