#include <cstdio>
#include <vector>
#include <queue>

using std::vector;

struct state {
	int v;
	std::vector <int> used;
	
	state(){}
	state(int _v, vector <int> _used) : v(_v), used(_used) {}
};

std::vector <std::vector <int> > g;

bool r, w;
int n, m;

bool used[16384];
int level;
int rev[1024];
vector <int> res;
vector <int> res2;
int cnt;

/*
int _dfs(int x) {
	for(int i = 0; i < g[x].size(); ++i) {
		if(!used[g[x][i]]) {
			list.push_back(g[x][i]);
			used[g[x][i]] = 1;
		}
	}
	for(int i = 0; i < list.size(); ++i) {
		int d = dfs(list[i]);
		if(m <= d) {
			m = d;
			p = list[i];
		}
	}
	for(int i = 0; i < list.size(); ++i) {
		used[list[i]] = 0;
	}
	
	rev[x] = p;
	return m+1;
}*/

int dfs(int x) {
	res.push_back(x);
	for(int i = 0; i < g[x].size(); ++i) {
		if(!used[g[x][i]]) {
			for(int j = 0; j < g[x].size(); ++j) {
				used[g[x][j]] = 1;
			}
			
			return (dfs(g[x][i]) + 1);
		}
	}
	
	return 0;
}

void bin(int x) {
	res2 = vector<int>(16, 0);
	for(int i = 0; !x; ++i) {
		res[i] = x % 2;
		x /= 2;
	}
	for(int i = m; i >=0; --i) {
		if(i != m)
			printf(" ");
		printf("%d", res[i]);
	}
	printf("\n");
}

bool is2(int x) {
	while(x % 2 == 0) {
		x /= 2;
	}
	
	if(x == 1)
		return true;
	return false;
}

int main() {
	scanf("%d", &m);
	if(n == 2) {
		printf("3\n");
		printf("0 0 0\n");
		printf("0 0 1\n");
		printf("0 1 1\n");
		return 0;
	} else if(n == 3) {
		printf("5\n");
		printf("0 0 0\n");
		printf("0 0 1\n");
		printf("0 1 1\n");
		printf("1 1 1\n");
		printf("1 1 0\n");
		return 0;
	}
	n = (1 << m);
	g.resize(n);
	for(int i = 0; i < n-1; ++i) {
		for(int j = 1; i + j < n; (j *= 2)) {
			if(is2(i^(i + j))) {
				g[i].push_back(i+j);
				g[i+j].push_back(i);
			}
		}
	
	}
	used[0] = 1;
	int r = dfs(0)+1;
	printf("%d\n", r);
//	for(int i = 0; i < res.size(); ++i) {
//		bin(res[i]);
// 	}
	
	/*
	r = 0;
	w = 1;
	q[0].push(state(0, vector <int>(1, 1)));
	
	while(true) {
		if(q[r].empty()) {
			if(q[w].empty()) {
				break;
			}
			r ^= 1;
			w ^= 1;
			++level;
		}
		state fr = q[r].front();
		for(int i = 0; i < g[fr.v].size(); ++i) {
			bool brk = false;
			for(int j = 0; j < fr.used.size(); ++j) {
				if(g[fr.v][i] == fr.used[j]) {
					brk = true;
					break;
				}
			}
			if(brk)
				continue;
			
			
		}
		
	}*/
	
/*	printf("\n");
	
	for(int i = 0; i < g.size(); ++i) {
		printf("%d:", i);
		for(int j = 0; j < g[i].size(); ++j) {
			printf(" %d", g[i][j]);
		}
		printf("\n");
	}
*/
}
