#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#define MAX(a,b) a > b ? a : b
#define MIN(a,b) a < b ? a : b
#define FOR(i, a, b) for(int i = a; i <= b; i++)
#define FORB(i, a, b) for(int i = a; i >= a; i--)
#define SIZE(v) v.size()
#define SHOW(v) cout << #v << " = " << v << endl;
#define MAXN 512
using namespace std;
vector < stack<int> > cols;
vector < stack<int> > lines;
bool usedcol[MAXN][MAXN];
bool usedline[MAXN][MAXN];
int data[MAXN][MAXN];
bool used[MAXN];
int n, m;
int iter = 0;
void print_solution()
{
  FOR(i, 1, n)
  {
    FOR(j, 1, n)
    {
      if (j == n) cout << data[i][j];
      else cout << data[i][j] << " ";
    }
    cout << endl;
  }
  exit(0);
}
/*
void put(int x, int y)
{
  if (y > n) return;
  if (x == n && y == n)
  {
    FOR(i, 1, n)
      if (!usedline[x][i] && !usedcol[y][i])
      {
        data[x][y] = i;
      }
    if(data[x][y] == 0) return;
    print_table();
    exit(0);
  }
  FOR(i, 1, n)
    if (!usedline[x][i] && !usedcol[y][i] && data[x][y] == 0)
    {
      usedline[x][i] = true;
      usedcol[y][i] = true;
      data[x][y] = i;
      cout << "put(" << x << ", " << y << ");" << " -> " << i << endl;
      if (y + 1 > n) put(x + 1, 1);
      else put (x, y + 1);
      data[x][y] = 0;
      usedline[x][i] = false;
      usedcol[y][i] = false;
    }
}
*/
void set_num(int x, int y, int num)
{
  usedcol[y][num] = true;
  usedline[x][num] = true;
  data[x][y] = num;
}
void rem_num(int x, int y, int num)
{
  usedcol[y][num] = false;
  usedline[x][num] = false;
  data[x][y] = 0;
}
void put(int num, int cnt)
{
  iter++;
  if (cnt > n && num >= n) print_solution();
  else if (cnt > n) put(num + 1, m + 1);
  else
  {
    FOR(i, 1, n)
    {
      if (!usedcol[i][num] && data[cnt][i] == 0)
      {
        set_num(cnt, i, num);
        //cout << "put(" << num << ", " << cnt << ");" << " -> " << i << endl;
        put(num, cnt + 1);
        rem_num(cnt, i, num);
      }
    }
  }
}
int main()
{
  int tmp = 0;
  cin >> m >> n;
  cout<<n<<endl;
  FOR(i, 1, m)
  {
    FOR(j, 1, n)
    {
      cin >> tmp;
      data[i][j] = tmp;
      usedline[i][tmp] = true;
      usedcol[j][tmp] = true;
      if (j == 1) used[tmp] = true;
    }
  }
  /*
  FOR(i, 1, n) SHOW(used[i]);
  */
  //int c = m + 1;
  //FOR(i, 1, n) if (!used[i]) set_num(c++, 1, i);
  //print_table();

  //put(m + 1, 2);
  /*int num = 0;
  FORB(i, n, 1)
  {
    num = i;
    FOR(j, m + 1, n)
      FOR(k, 1, n)
      {
        if(!usedcol[k][num] && data[j][k] == 0)
        {
          set_num(j, k, num);
          break;
        }
      }
  }
  print_solution();
  */
  put(1, m + 1);
  return 0;
}
