#include <iostream>
#include <cmath>
using namespace std;

const double PI2 = 2*M_PI;

double calcAng(double l, double v) 
{
    double c, ang_adj = 0, v90, p;
    c = (2*l*l - v*v)/(2*l*l);
    if (c > 1 || c < -1) {
       v90 = sqrt(2*l*l);
       while (v > 0) {
             v-=v90;
             ang_adj += M_PI_2;
       }
       v += v90;
       c = (2*l*l - v*v)/(2*l*l);
    }

    
    return acos(c) + ang_adj;
}

int main()
{
    
    int x1, y1, d1, x2, y2, d2, k, br=0, t=0;
    double v1, v2, ang1, ang2, pos1, pos2, l1, l2, newpos1, newpos2;
    scanf("%d%d%lf%d%d%d%lf%d%d", &x1, &y1, &v1, &d1, &x2, &y2, &v2, &d2, &k);
    l1 = sqrt(x1*x1 + y1*y1);
    l2 = sqrt(x2*x2 + y2*y2);
    ang1 = calcAng(l1, v1);
    ang2 = calcAng(l2, v2);
    
    pos1 = acos(x1/l1);
    pos2 = acos(x2/l2);
    
    if (pos1 == pos2) br++;
    while (br < k) {
          ++t;
          newpos1 = pos1 + ang1;
          newpos2 = pos2 + ang2;
          if (newpos1 >= newpos2 && pos1 <= pos2) br++;
          else if (newpos2 >= newpos1 && pos2 <= pos1) br++;
          if (newpos1 > PI2) newpos1 -= PI2;
          if (newpos2 > PI2) newpos2 -= PI2;
          
          pos1 = newpos1;
          pos2 = newpos2;
          
    }
    
    printf("%d\n", t);
    
    return 0;
}    
