#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int n;
short used[16384], prev[16384];
int deepest, cdepth;

vector<short> last_deepest;

void set_neigh(short pos, int val) {
	for(short mask = 1; mask < 1<<n; mask <<= 1) {
		used[pos^mask] += val;
	}
}

void rec(short pos) {
	//printf("%senter %d\n", string(cdepth, '\t').c_str(), pos);
	++cdepth;
	if(cdepth > deepest) {
		deepest = cdepth;
		last_deepest.clear();
		short cpos = pos;
		while(cpos != 0) {
			last_deepest.push_back(cpos);
			cpos = prev[cpos];
		}
		last_deepest.push_back(0);
		reverse(last_deepest.begin(), last_deepest.end());
	}
	
	++used[pos];
	for(short mask = 1; mask < 1<<n; mask <<= 1) {
		if(!used[pos^mask]) {
			set_neigh(pos, 1);
			
			prev[pos^mask] = pos;
			rec(pos^mask);
			
			//set_neigh(pos, -1);
		}
	}
	//--used[pos];
	
	--cdepth;
	//printf("%sleave %d\n", string(cdepth, '\t').c_str(), pos);
}

void print_bin(short b) {
	for(int i = 1<<(n-1); i; i >>= 1) {
		printf("%d ", b&i ? 1 : 0);
	}
	printf("\n");
}

int main() {
	scanf("%d", &n);
	used[0] = 1;
	rec(0);
	printf("%d\n", deepest);
	for(int i = 0; i < last_deepest.size(); ++i)
		print_bin(last_deepest[i]);
	//printf("%d\n", deepest);
	return 0;
}
