#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

bool G[1<<15];
int n, answer;
vector < int > a;

void show()
{
    for (int i=0; i<(1<<n); ++i)
        cout << G[i] << " ";
    cout << endl;
}

void toBin(int at)
{
    for (int mask=1<<(n-1); mask; mask>>=1)
    {
        if (at & mask)
            printf("1 ");
        else
            printf("0 ");
    }
    printf("\n");
}

void solve(int current, int level)
{
    G[current]=1;
    a.push_back(current);
    if (level > answer)
        answer=level;
    for (int i=0; i<n; ++i)
    {
        if (G[current^(1<<i)] == 0)
        {
            for (int j=0; j<n; ++j)
                G[current^(1<<j)]=1;
            solve(current^(1<<i), level+1);
        }
    }
}

inline void input()
{ scanf("%d", &n); }

int main()
{
    input();
    solve(0, 0);
    cout << answer+1 << endl;
    for (int i=0; i<a.size(); ++i)
        toBin(a[i]);
return 0;
}
