#include <cstdio>
#include <cmath>

#define pi 3.1415926535897932384626433832795

int a1, b1, v1, d1;
int a2, b2, v2, d2;
int k;
double p1, p2;
int t;

void fix() {
	if(p1 > 360)
		p1 -= 360;
	if(p1 < -360)
		p1 += 360;
	if(p2 > 360)
		p2 -= 360;
	if(p2 < -360)
		p2 += 360;
}

int main() {
	scanf("%d%d%d%d", &a1, &b1, &v1, &d1);
	scanf("%d%d%d%d", &a2, &b2, &v2, &d2);
	scanf("%d", &k);
	
	v1 *= d1;
	v2 *= d2;
	
	p1 = 180*atan2(b1, a1)/pi;
	p2 = 180*atan2(b2, a2)/pi;
	
	for(int i = 0; ; ++i) {
		if((int)p1 == (int)p2) {
			++t;
		}
		if(t == k) {
			printf("%d\n", i/63);
			return 0;
		}
		p1 += v1;
		p2 += v2;
		fix();
	}
	
	return 0;
}
